<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/TR/REC-html40"> 
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>fwAccessControl_Setup.pnl 
panel</title>
<link rel="StyleSheet" HREF="style.css" TYPE="text/css" MEDIA="screen,print">
</head>
<body>
<table width="95%" border="1"><tbody>
<tr vAlign="top">
<td width="22%" bgColor="#00cc00"><strong>Panel Name</strong></td>
<td width="78%" colSpan="2">fwAccessControl/fwAccessControl_Setup.pnl</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Introduction<br></strong></td>
<td colSpan="2">
<p>Setup panel</p>
<p> 
	<p>
	The setup panel is used to configure the Access Control component - it allows
	to specify the access rights that will be required to perform certain operations
	(administration, datapoint and datapoint type creation, etc), configure the
	Integrated Access Control (i.e. access control management through the Access Control Server),
	and export the Access Control data. <br>
	The Setup panel is presented in Figure 1:
	    <div xmlns:html="http://www.w3.org/1999/xhtml" class="figure"><table align="center">
<tr><td><img src="fwAccessControl_Setup.png"></td></tr>
<tr><td><span class="caption">Figure 1: Access Control Setup panel.</span></td></tr>
</table></div>
	</p>


    <h3>Admininstration Privileges</h3>
	<p>
	The Access Control components defines and uses the following four roles, which are related
	to the configuration and management tasks. The actual access rights (i.e. domain name and
	privilege level associated with the role) are configurable in this panel.
	<dl>
	    <dt>Domain Administration</dt>
	    <dd> the users who are granted the aceess rights related to this role are
	    allowed to configure Access Control domains, i.e. delete, create and modify them.
	    Other users are only allowed to display the information about domains. <br>
	    Typically domain administration tasks should only be available to the central
	    team, responsible for integrity of the system. Proper definition of domain
	    and privilege names needs to be assured to make the access control mechanisms
	    work in all systems (note that the access rights, i.e. domain name and privilege name,
	    need to be hardcoded in the panels, and they need to be consistent on all systems
	    on which the panels are used!). Typically, the domain names and privilege names should
	    be pre-defined by the Central Team, and defined on the Access Control Server, and the
	    names handed-over to the developers of the subsystems. There should be no need to modify
	    the domains after the subsystems which refer to them are integrated.
	    </dd>

	    <dt>Group Administration</dt>
	    <dd> the users who are granted the aceess rights related to this role are
	    allowed to configure Access Control groups, i.e. delete, create and modify them.
	    Other users are only allowed to display the information about groups. <br>
	    Groups administration consists of the definition of the access rights
	    that are needed to perform certain tasks, it is therefore related to the definition
	    of "roles" in the system. After initial definition of the groups (roles) in the system, 
	    it should rarely be needed to change the settings of existing groups. New groups
	    may be created to streamline the assignment of users to roles, however. Group administration
	    should therefore be reserved, as in the case of domain administration, to the Central Team.
	    </dd>


	    <dt>User Administration</dt>
	    <dd> the users who are granted the aceess rights related to this role are
	    allowed to perform user administration tasks, i.e. delete, create and modify user accounts
	    (including the change of the password).
	    Others are only allowed to display the information, and modify some details of their own
	    accounts).<br>
	    User administration tasks are going to be the bulk of Access Control - management operations,
	    once the system is set up. Typical tasks involve creating new user accounts, disabling of the
	    accounts of users who do not work in the project anymore, resetting the passwords, adjustments
	    in users' group assignments reflecting the roles to be played. It is therefore envisaged that
	    the user management tasks need to be available to a number of trusted users, such as subdetector
	    experts.
	    </dd>

	    <dt> System Administration</dt>
	    <dd> This role gives full control over the configuration of the access control.
	    It is required to be able to change the settings in the Setup panel, and also has
	    the Domain Administration, Group Administration and User Administration access rights. <br>
	    In the current implementation the System Administration role is bound to the <em>root</em>
	    account; this assignment may not be changed.
	    </dd>
	</dl>
    </p>
    
    <h3>Panel elements</h3>
    <p>
	The panel is organized in functional areas. The top-right corner contains the
	<a href="fwAccessControl_CurrentUser.htm">Current User</a>  indicator (with
	login <img class="button" align="center" src="login.png"> button) and help button. The central part contained
	in the <em>Access rights required for</em> frame contains the elements allowing
	to define the access rights required to perform certain operations and related to the
	administration privileges. The <em>Access Control Server</em> frame below
	contains the elements related to the Integrated Acccess Control mode, and the management
	of the Access Control Server. The objects at the bottom of the panel are used for other,
	special tasks. Let us describe all these objects in detail:
    </p>
    <ul>
	<li> the Current User indicator and login button are described
	    <a href="fwAccessControl_CurrentUser.htm">elsewhere</a> .
	</li>
	<li>the <em>"Access rights required for"</em> frame:<br>
	    comprises two columns of widgets allowing to specify the complete access
	    right for each line: the domain name in the first column, and the privilege level
	    in this domain - in the second column. <br>
	    The first three lines allow to select
	    the access rights associated with administration tasks (see the <em>Administration Privileges</em>
	    above) - it is possible to select the domain and privilege level.<br>	    
	    The next four lines allow to define the access rights related to certain PVSS
	    operations: <ul>
		<li> <em>DPT create/update/delete</em>: the operations related
		    to PVSS DataPoint Type operations. It is possible to restrict the
		    create/delete/modify operations on Data Point Type by configuring this
		    privilege level. In the example presented in Figure 1, only the users
		    having the <em>Administration</em> privilege level in the system
		    domain (indicated as <em>ACServer</em>) will be allowed to
		    perform these operations. <br>
		    In the final (production) systems the operations on PVSS Data Point Types
		    should be restricted, as they may severly affect the functionality of the
		    project. We recommend that only experts have associated privileges.
		</li>
		<li>
<em>DP create/delete</em>: the creation and removal of
		    PVSS DataPoint operations. As above, these operations may affect
		    the stability of the project, hence it may be desirable to restrict them.<br>
		    We recommend that in final (production) system these operations are reserved
		    for experts.
		</li>
		<li>
<em>DP alias edit</em>: changing the data point alias is usually
		related to the operation of re-connection, i.e. the change in the association
		between the items in LOGICAL and HARDWARE hierarchies. It may be desirable to
		restrict such operations to be available only for certain set of privileged
		users (e.g. shifters in the control room, or subdetector experts).
		</li>
		<li>
<em>DP auth edit</em>: even though it is not recommended by the
		JCOP Framework, it is possible to put the authorizations on individual 
		data points (strictly speaking: dp configs) in PVSS (for more details please
		consult PVSS documentation). The access right that are declared here are needed
		in order to be able to set up such authorizations on any PVSS datapoint. <br>
		Following the example in Figure 1, only the users having the <em>AuthControl</em>
		privilege level in the system domain (indicated as <em>ACServer</em> will be
		allowed to set the authorization of datapoints. Once such authorization was configured
		for a datapoint config (such as _address), the modifications to this config of the
		datapoint will only be effective if the user has certain system privilege level;
		the protection will be actually enforced by PVSS Event manager.
		</li>
	    </ul>
	</li>
	
	<li> the <em>"Access Control Server"</em> frame
	    <ul>
		<li> the <em>"Host"</em> selection box allows to select the 
		    system on which the Access Control Server is running. The list contains
		    the names of all systems to which distributed connection was established.<br>
		    To disable the use of the Access Control Server, the <code>(none)</code>
		    entry should be selected.<br>
		    Note that changes are applied immediately.
		</li>
		<li>
<em>Status</em> In the current implementation this field displays
		the most recent reply from the Access Control Server. This will be changed in future 
		implementations
		</li>
		<li>
<span class="button">Server Console</span> Opens the 
		<a href="fwAccessControl_ServerConsole.htm">Server Console</a>  panel.
		The button is enabled only if the selected <em>Host</em> is the local system,
		which means that the local system is actually the Access Control Server. <br>
		The server console displays the list of systems in the distributed system, indicates
		whether the system is managed by the Access Control server, allows to
		modify the "Access Control Server Host" setting of remote systems (i.e. force them to
		be managed by the server) and trigger the synchronization of the access control data.
		</li>
	    </ul>
	</li>
	
	<li> <em>Enable Access Control</em> switch: allows to activate/deactivate access
	control in the system. When the switch is activated, all of the Access Control mechanisms are
	engaged. When the switch is deactivated, user's access rights are actually not checked - all users
	are granted all access rights in the system (with the exception of the System Administration).
	The users still have to log in with a valid user name and password, though.<br>
	The fact that Access Control is disabled is indicated by a yellow frame around 
	the <a href="fwAccessControl_CurrentUser.htm">Current User</a>  indicator.
	<br>
	Note that changes in the state of the switch are applied immediately!
	</li>

	<li> <span class="button">Export...</span> button: allows to export domains, groups and users to 
	    a file, which is suitable for being used with the Framework Installation Tool.<br>
	    It allows to select the file name, then
	    brings up the  <a href="fwAccessControl_Export.htm">Export</a>  panel,
	    that allows to select the objects to be exported.
	</li>
	
    </ul>
    
    </p>
<br>
</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Instructions</strong></td>
<td colSpan="2"><dl>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To enable Integrated Access Control mode (the use of Access Control Server):</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Set the <em>Host</em> in the <em>Access Control Server</em> frame to the name
	of the system on which the Access Control Server is running. Note that the definition of all
	local domains, groups and users will be overwritten immediately by the ones managed by server!
	Consider exporting the local Access Control data to a file beforehand (using the <span class="button">Export</span> button.
	<br>
	Note that the changes will be applied immediately after selection is made!
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To disable Integrated Access Control mode:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Set the <em>Host</em> in the <em>Access Control Server</em> frame to <code>(none)</code>.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To start the Access Control Server:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Start a CTRL manager with <code>fwAccessControl/fwAccessControl_Server.ctc</code> script.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To export Access Control Data:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	<ul>
	<li> Press the <span class="button">Export...</span> button</li>
	<li> in the file selector, navigate to the directory where you want to store the file,
	and type in the name of the file. Note that you must not select an existing file (i.e. 
	overwrite operation will be refused). </li>
	<li> <a href="fwAccessControl_Export.htm">Export</a>  panel will be displayed,
	allowing you to select domains, groups and users you wish to export; please follow the instrutctions
	for that panel </li>
	</ul>    
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To enable/disable access control:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	use the <em>Enable Access Control</em> switch. When access control is disabled,
	a yellow frame is displayed around the <a href="fwAccessControl_CurrentUser.htm">Current User</a>  indicator,
	and all users are granted all privileges. <br>
	Note! Use with caution - for debuging or to provide temporary access in case of problems.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To close the panel:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml"> Press the <span class="button">Close</span> button </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To apply the changes in access rights assignments:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml"> 
	Press the <span class="button">Apply</span> button. <br>
	Note that the panel will not be closed - you need to use the <span class="button">Close</span> button.<br>
	Note that the changes in the settings of the <em>Access Control Server</em> and
	the state of the <em>Enable Access Control</em> switch are applied immediately upon any change.
	</dd>
</dl></td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Restrictions</strong></td>
<td colSpan="2"><ul><li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>Access_Setup:</strong> To alter the settings you need the System Administration access rights.
	In the current implementation only the user <em>root</em> has this privileges.
    </li></ul></td>
</tr>
</tbody></table>
<br>

<br><a href="../../fwAccessControl.htm">
Back to the documentation of the
	    fwAccessControl
component.
	    </a> <br xmlns:html="http://www.w3.org/1999/xhtml"><hr xmlns:html="http://www.w3.org/1999/xhtml">
<font xmlns:html="http://www.w3.org/1999/xhtml" size="-1"> Piotr Golonka, <a href="http://cern.ch/itcobe">CERN IT/CO-BE</a></font>
</body></html>
